## JavaWeb开发笔记

![](assets/note.jpg)

> 十年生死两茫茫，不思量，自难忘，华年短暂，陈辞岁月悠悠伤，
>
> 满腔热血已芜荒，展未来，后生强，战战兢兢，如履薄冰心彷徨，
>
> 青丝化雪、鬓角成霜，已是英雄迟暮，人生怎慷慨激昂？

对于一个开发者而言，能够胜任系统中任意一个模块的开发是其核心价值的体现。

对于一个架构师而言，掌握各种语言的优势并可以运用到系统中，由此简化系统的开发，是其架构生涯的第一步。

对于一个开发团队而言，能在短期内开发出用户满意的软件系统是起核心竞争力的体现。

每一个程序员都不能固步自封，要多接触新的行业，新的技术领域，突破自我。

## GitHub托管

**https://github.com/JackChen1999/JavaWeb**  

请读者点击Star进行关注并支持！

## GitBook在线阅读

在线阅读，PDF、ePub、Mobi电子书下载

**https://alleniverson.gitbooks.io/javaweb/content**

## 目录

* [前言](https://alleniverson.gitbooks.io/javaweb/content/)
* [1. HTML](https://alleniverson.gitbooks.io/javaweb/content/第1章%20HTML/)
  * [HTML](https://alleniverson.gitbooks.io/javaweb/content/第1章%20HTML/HTML.html)
  * [HTML5](https://alleniverson.gitbooks.io/javaweb/content/第1章%20HTML/HTML5.html)
* [2. CSS](https://alleniverson.gitbooks.io/javaweb/content/第2章%20CSS)
  * [CSS](https://alleniverson.gitbooks.io/javaweb/content/第2章%20CSS/CSS.html)
  * [CSS3](https://alleniverson.gitbooks.io/javaweb/content/第2章%20CSS/CSS3.html)
* [3. JavaScript](https://alleniverson.gitbooks.io/javaweb/content/第3章%20JavaScript)
  * [JavaScript基础入门](https://alleniverson.gitbooks.io/javaweb/content/第3章%20JavaScript/JavaScript.html)
  * [JavaScript 知识图谱](https://alleniverson.gitbooks.io/javaweb/content/第3章%20JavaScript/JavaScript%20知识图谱.html)
  * [JavaScript常用代码集合](https://alleniverson.gitbooks.io/javaweb/content/第3章%20JavaScript/JavaScript常用代码集合.html)
* [4. XML解析器](https://alleniverson.gitbooks.io/javaweb/content/第4章%20XML基础/XML解析器.html)
* [5. JavaWeb开发入门](https://alleniverson.gitbooks.io/javaweb/content/第5章%20Tomcat开发Web站点/JavaWeb开发入门.html)
* [6. 网络编程](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议)
  * [6.1 网络编程](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/网络编程.html)
  * [6.2 你应该知道的计算机网络知识](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/你应该知道的计算机网络知识.html)
  * [6.3 Http协议](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/Http协议.html)
  * [6.4 HTTP协议详解](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/HTTP协议详解.html)
  * [6.5 HTTP协议图解](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/HTTP协议图解.html)
  * [6.6 HTTP响应报文与工作原理详解](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/HTTP响应报文与工作原理详解.html)
  * [6.7 常见的HTTP状态码深入理解](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/常见的HTTP状态码深入理解.html)
  * [6.8 写给那些让我糊里糊涂的HTTP、TCP、UDP、Socket](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/写给那些让我糊里糊涂的HTTP、TCP、UDP、Socket.html)
  * [6.9 GET与POST的区别](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/GET与POST的区别.html)
  * [6.10 Https扫盲贴](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/Https扫盲贴.html)
  * [6.11 Wireshark基本介绍和学习TCP三次握手](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/Wireshark基本介绍和学习TCP三次握手.html)
  * [6.12 Wireshark抓包实战](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/Wireshark抓包实战.html)
  * [6.13 Fidder抓包](https://alleniverson.gitbooks.io/javaweb/content/第6章%20Http协议/Fidder.html)
  * [6.14 网络安全](第6章 Http协议/网络安全.md)
* [7. Servlet技术](https://alleniverson.gitbooks.io/javaweb/content/第7章%20Servlet/Servlet.html)
* [8. 请求和响应](https://alleniverson.gitbooks.io/javaweb/content/第8章%20请求响应/HttpServletResponse和HttpServletRequest.html)
* [9. 会话跟踪技术](https://alleniverson.gitbooks.io/javaweb/content/第9章%20会话及其会话技术)
  * [9.1 Cookie和Session](https://alleniverson.gitbooks.io/javaweb/content/第9章%20会话及其会话技术/Cookie和Session.html)
  * [9.2 Cookie-Session机制详解](https://alleniverson.gitbooks.io/javaweb/content/第9章%20会话及其会话技术/Cookie-Session机制详解.html)
* [10. 数据库](https://alleniverson.gitbooks.io/javaweb/content/第10章%20MySQL)
  * [10.1 MySQL数据库](https://alleniverson.gitbooks.io/javaweb/content/第10章%20MySQL/MySQL数据库.html)
  * [10.2 MySQL数据库：SQL语句](https://alleniverson.gitbooks.io/javaweb/content/第10章%20MySQL/MySQL数据库：SQL语句.html)
  * [10.3 MySQL数据库：完整性约束](https://alleniverson.gitbooks.io/javaweb/content/第10章%20MySQL/MySQL数据库：完整性约束.html)
  * [10.4 用JDBC操作数据库](https://alleniverson.gitbooks.io/javaweb/content/第11章%20JDBC/用JDBC操作数据库.html)
  * [10.5 JDBC之数据库连接池](https://alleniverson.gitbooks.io/javaweb/content/第11章%20JDBC/JDBC之数据库连接池.html)
  * [10.6 JDBC之事务](https://alleniverson.gitbooks.io/javaweb/content/第11章%20JDBC/JDBC之事务.html)
* [11. 上传下载文件](https://alleniverson.gitbooks.io/javaweb/content/第12章%20上传下载)
  * [11.1 上传下载文件](https://alleniverson.gitbooks.io/javaweb/content/第12章%20上传下载/上传下载文件.html)
  * [11.2 手动实现文件上传](https://alleniverson.gitbooks.io/javaweb/content/第12章%20上传下载/Upload.html)
  * [11.3 酷炫的文件上传技术](https://alleniverson.gitbooks.io/javaweb/content/第12章%20上传下载/酷炫的文件上传技术.html)
* [12. JavaMail邮件开发](https://alleniverson.gitbooks.io/javaweb/content/第13章%20邮件开发/JavaMail.html)
* [13. 过滤器Filter](https://alleniverson.gitbooks.io/javaweb/content/第14章%20过滤器/过滤器Filter.html)
* [14. AJAX](https://alleniverson.gitbooks.io/javaweb/content/第15章%20AJAX/AJAX.html)
* [15. JSP入门](https://alleniverson.gitbooks.io/javaweb/content/第16章%20JSP/JSP入门.html)
* [16. JSTL标签库](https://alleniverson.gitbooks.io/javaweb/content/第17章%20JavaWeb开发/JSTL标签库.html)
* [17. MVC设计模式](https://alleniverson.gitbooks.io/javaweb/content/第17章%20JavaWeb开发/MVC设计模式.html)
* [18. 在线支付](https://alleniverson.gitbooks.io/javaweb/content/第17章%20JavaWeb开发/在线支付.html)
* [19. Jquery](https://alleniverson.gitbooks.io/javaweb/content/第17章%20JavaWeb开发/Jquery.html)

## 关注我

- Email：<619888095@qq.com>
- CSDN博客：[Allen Iverson](http://blog.csdn.net/axi295309066)
- 新浪微博：[AndroidDeveloper](http://weibo.com/u/1848214604?topnav=1&wvr=6&topsug=1&is_all=1)
- GitHub：[JackChan1999](https://github.com/JackChan1999)
- GitBook：[alleniverson](https://www.gitbook.com/@alleniverson)
- 个人博客：[JackChan](https://jackchan1999.github.io/)

如果觉得我的文章对您有用，请随意打赏。您的支持将鼓励我继续创作！

|                  微信赞赏支持                  |                 支付宝赞赏支持                  |
| :--------------------------------------: | :--------------------------------------: |
| <img src="assets/weixin.png" width="300" /> | <img src="assets/支付宝.jpg" width="300" /> |
