# 1. 数据库概念
## 1.1 什么是数据库
数据库就是用来存储和管理数据的仓库！

数据库存储数据的优点：

- 可存储大量数据
- 方便检索
- 保持数据的一致性、完整性
- 安全，可共享
- 通过组合分析，可产生新数据

## 1.2 数据库的发展历程
- 没有数据库，使用磁盘文件存储数据
- 层次结构模型数据库
- 网状结构模型数据库
- 关系结构模型数据库：使用二维表格来存储数据
- 关系-对象模型数据库

MySQL就是关系型数据库！

# 2. SQL语言

- Structured Query Language, 结构化查询语言
- 非过程性语言
- 美国国家标准局(ANSI）与国际标准化组织（ISO）已经制定了SQL标准
- 为加强SQL的语言能力，各厂商增强了过程性语言的特征
- 如Oracle的PL/SQL 过程性处理能力
- SQL Server、Sybase的T-SQL
- SQL是用来存取关系数据库的语言，具有查询、操纵、定义和控制关系型数据库的四方面功能

# 3. MySQL数据库服务器、数据库和表的关系
所谓安装数据库服务器，只是在机器上装了一个数据库管理程序，这个管理程序可以管理多个数据库，一般开发人员会针对每一个应用创建一个数据库。

为保存应用中实体的数据，一般会在数据库创建多个表，以保存程序中实体的数据。

数据库服务器、数据库和表的关系如图所示：

![mysql](http://img.blog.csdn.net/20161030225213981)
# 4. 常见数据库

- Oracle（神喻）：甲骨文（最高！）
- DB2：IBM
- SQL Server：微软
- Sybase：赛尔斯
- MySQL：甲骨文

# 5. 理解数据库
- RDBMS = 管理员（manager）+仓库（database）
- database = N个table
- table：表
- 表结构：定义表的列名和列类型！
- 表记录：一行一行的记录！表的一行称之为一条记录，表中一条记录对应一个java对象的数据

我们现在所说的数据库泛指“关系型数据库管理系统（RDBMS - Relational database management system）”，即“数据库服务器”。

![mysql](http://img.blog.csdn.net/20161027143912383)

当我们安装了数据库服务器后，就可以在数据库服务器中创建数据库，每个数据库中还可以包含多张表。

![mysql](http://img.blog.csdn.net/20161027143951196)

数据库表就是一个多行多列的表格。在创建表时，需要指定表的列数，以及列名称，列类型等信息。而不用指定表格的行数，行数是没有上限的。下面是tab_student表的结构：

![mysql](http://img.blog.csdn.net/20161027144022774)

当把表格创建好了之后，就可以向表格中添加数据了。向表格添加数据是以行为单位的！下面是s_student表的记录：

| s_id   | s_name   | s_age | s_sex  |
| :----- | :------- | :---- | :----- |
| s_1001 | zhangSan | 23    | male   |
| s_1002 | liSi     | 32    | female |
| s_1003 | wangWu   | 44    | male   |

# 6. 应用程序与数据库
![mysql](http://img.blog.csdn.net/20161027145305435)
